part of 'chat_list_bloc.dart';

abstract class ChatListEvent {}

class ChatListInitEvent extends ChatListEvent {}

class ChatListUpdateConversationEvent extends ChatListEvent {
  final String id;
  final Map<String, dynamic> data;

  ChatListUpdateConversationEvent(this.id, this.data);
}

class ChatListRemoveEvent extends ChatListEvent {
  final String conversationId;

  ChatListRemoveEvent(this.conversationId);
}

class ChatListFilterByKeywordEvent extends ChatListEvent {
  final String searchKeyword;

  ChatListFilterByKeywordEvent(this.searchKeyword);
}

class ChatListReadItemEvent extends ChatListEvent {
  ChatListConversation? c;

  String? firebaseId;
  ChatDetailType? detailType;
  String? fullName;
  String? thumbnail;

  ChatListReadItemEvent(
      {this.c,
      this.firebaseId,
      this.fullName,
      this.thumbnail,
      this.detailType});
}

class ChatListDisposeEvent extends ChatListEvent {}
