part of 'chat_list_bloc.dart';

class ChatListState {
  final bool isLoading;
  final List<ChatListConversation> conversations;
  final String searchKeyword;
  final int unread;
  final Map usersByKeys;

  ChatListState({
    required this.searchKeyword,
    required this.conversations,
    required this.usersByKeys,
    this.unread = 0,
    this.isLoading = true,
  });

  ChatListState update({
    int? unread,
    bool? isLoading,
    List<ChatListConversation>? conversations,
    String? searchKeyword,
    Map? usersByKeys,
  }) {
    return ChatListState(
      usersByKeys: usersByKeys ?? this.usersByKeys,
      searchKeyword: searchKeyword ?? this.searchKeyword,
      unread: unread ?? this.unread,
      isLoading: isLoading ?? this.isLoading,
      conversations: conversations ?? this.conversations,
    );
  }
}
