import 'package:flutter/material.dart';
import 'package:flutter_bloc/flutter_bloc.dart';
import 'package:get/get.dart';

import 'bloc/chat_list_bloc.dart';
import 'widget/widget_conversation_item.dart';

class ChatListScreen extends StatefulWidget {
  final Widget Function(ChatListState state)? builder;
  const ChatListScreen({Key? key, this.builder}) : super(key: key);

  static String route = '/chat_list';

  @override
  State<ChatListScreen> createState() => _ChatListScreenState();
}

class _ChatListScreenState extends State<ChatListScreen> {
  @override
  void initState() {
    super.initState();
    Get.find<ChatListBloc>().add(ChatListInitEvent());
  }

  @override
  Widget build(BuildContext context) {
    return Material(
      color: Colors.transparent,
      child: BlocBuilder<ChatListBloc, ChatListState>(
          bloc: Get.find<ChatListBloc>(),
          builder: (_, state) {
            if (widget.builder != null) {
              return widget.builder!(state);
            }
            return ListView.builder(
              physics: const BouncingScrollPhysics(),
              itemCount: state.conversations.length,
              itemBuilder: (BuildContext _, index) {
                var m = state.conversations[index];
                return WidgetConversationItem(m: m);
              },
            );
          }),
    );
  }
}
