import 'package:flutter/material.dart';
import 'package:flutter_bloc/flutter_bloc.dart';
import 'package:get/get.dart';
import 'package:_private_chat/_private_chat.dart';
import 'package:_private_core/_private_core.dart';

class WidgetProfileChatListBuilder extends StatelessWidget {
  final Widget Function(String fullname, String thumbnal, Map conversationData)
      builder;
  final ChatConversationType conversationType;
  //Id of user or conversation
  final String id;
  const WidgetProfileChatListBuilder({
    Key? key,
    required this.conversationType,
    required this.id,
    required this.builder,
  }) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return BlocBuilder<ChatListBloc, ChatListState>(
      bloc: Get.find<ChatListBloc>(),
      builder: (_, state) {
        String fullname() {
          if (conversationType == ChatConversationType.solo) {
            Map? user = state.usersByKeys[id];
            return chatGetFullNameUser(user);
          } else {
            if (state.conversations.any((e) => e.conversationId == id)) {
              return state.conversations
                      .firstWhere((e) => e.conversationId == id)
                      .data[DB_KEY_GROUP_NAME] ??
                  '';
            } else {
              return '';
            }
          }
        }

        String thumbnail() {
          if (conversationType == ChatConversationType.solo) {
            Map? user = state.usersByKeys[id];
            return chatGetThumbnailUser(user);
          } else {
            if (state.conversations.any((e) => e.conversationId == id)) {
              return state.conversations
                      .firstWhere((e) => e.conversationId == id)
                      .data[DB_KEY_THUMBNAIL] ??
                  '';
            } else {
              return '';
            }
          }
        }

        return builder(
            fullname(),
            thumbnail(),
            state.conversations.any((e) => e.conversationId == id)
                ? state.conversations
                    .firstWhere((e) => e.conversationId == id)
                    .data
                : {});
      },
    );
  }
}
