import 'package:flutter/material.dart';
import 'package:_private_core/_private_core.dart';
import '../chat_detail/chat_helper.dart';
import '../widgets/widget_top_notification.dart';
import '../widgets/widget_top_sheet.dart';

int getTimestamp(data) => data[DB_KEY_TIMESTAMP];

String getContent(key, data) => ChatHelper.decrypt(key, data[DB_KEY_CONTENT]);

bool getIsMe(data) => data[DB_KEY_FROM] == loggedFirebaseId;

String get loggedFirebaseId => appPrefs.loginUser!.firebaseId;

Future showTopMessage(
    {required String title, Widget? icon, bool? grip = true}) async {
  return await showTopModalSheet(
    child: WidgetTopNotification(
      title: title,
      icon: icon,
      grip: grip,
    ),
  );
}

Future showTopMessageCustom({
  required Widget child,
  Color? backgroundColor,
  Color? gripColor,
}) async {
  return await showTopModalSheet(
    child: WidgetTopNotificationCustom(
      child: child,
      backgroundColor: backgroundColor,
      gripColor: gripColor,
    ),
  );
}
